# -*- coding: utf-8 -*-
"""
Created on Fri Feb  2 15:52:16 2018

Run generations of patterns

@author: oddvi
"""

#import patternGenerators as gen

import shapely.geometry
import shapely.affinity
import shapely.ops
from shapely.geometry import Polygon

"""
Save as SVG
"""

def makeSVGstring(polygon, unit, border):
        """SVG representation for iPython notebook"""
        svg_top = '<svg xmlns="http://www.w3.org/2000/svg" ' \
            'xmlns:xlink="http://www.w3.org/1999/xlink" '
        scale_factor=1
        if polygon.is_empty:
            return svg_top + '/>'
        else:
            border_string = ''
            # Establish SVG canvas that will fit all the data + small space
            xmin, ymin, xmax, ymax = polygon.bounds
            if xmin == xmax and ymin == ymax:
                # This is a point; buffer using an arbitrary size
                xmin, ymin, xmax, ymax = polygon.buffer(1).bounds
            else:
               #Creates a border if there is none
                if border:
                    x = [xmin, xmin, xmax, xmax]
                    y = [ymin, ymax, ymax, ymin]
                    border_polygon = Polygon(list(zip(x,y)))
                    border_string = border_polygon.svg(scale_factor)
                # Expand bounds by a fraction of the data ranges
                expand = 0.04  # or 4%, same as R plots
                widest_part = max([xmax - xmin, ymax - ymin])
                expand_amount = widest_part * expand
                xmin -= expand_amount
                ymin -= expand_amount
                xmax += expand_amount
                ymax += expand_amount
            dx = xmax - xmin
            dy = ymax - ymin
            width = dx
            height = dy
            view_box = "{0} {1} {2} {3}".format(xmin, ymin, dx, dy)
            transform = "matrix(1,0,0,-1,0,{0})".format(ymax + ymin)
            return svg_top + (
                'width="{1}{0}" height="{2}{0}" viewBox="{3}" '
                'preserveAspectRatio="xMinYMin meet">'
                '<g transform="{4}">{5}{6}{5}</g></svg>'
                ).format(unit, width, height, view_box, transform,
                         border_string, polygon.svg(scale_factor))
            
def scaleToPage(polygon, pref):
    xmin, ymin, xmax, ymax = polygon.bounds
    dx = xmax-xmin
    return shapely.affinity.scale(polygon, xfact=pref/dx , yfact=pref/dx)

def createSVG(polygon, path, name, width, mode, cut, unit, stroke_width):
    xmin, ymin, xmax, ymax = polygon.bounds
    border = False
    if mode == 0:
        polygon = scaleToPage(polygon, width)
    if not cut:
        border = True
    polygon_svg = makeSVGstring(polygon, unit, border)
    filepath = path + "\\" + name
    file=open(filepath,'w')
    if mode == 's':
        polygon_svg = polygon_svg.replace('stroke-width="2.0"','stroke-width="0.265"'+unit)
        polygon_svg = polygon_svg.replace('stroke="#66cc99"','stroke="#555555"')
        polygon_svg = polygon_svg.replace('opacity="0.6"', 'opacity="1.0"')
    else:
        polygon_svg = polygon_svg.replace('stroke-width="2.0"','stroke-width="'+str(stroke_width)+'"')
        polygon_svg = polygon_svg.replace('stroke="#555555"','stroke="#000000"')
        polygon_svg = polygon_svg.replace('stroke="#66cc99"','stroke="#000000"')
        polygon_svg = polygon_svg.replace('fill="#66cc99"','fill="none"')
        polygon_svg = polygon_svg.replace('opacity="0.6"', 'opacity="1.0"')
    file.write(polygon_svg)
    file.close()
    return


    


"""
Save
"""

if __name__ == '__main__':
    'smthng'
#    p = scaleToPage()x